name: Build-Test-Publish
run-name: Build test and publish all tools

on: [push]

defaults:
  run:
    shell: bash

jobs:
  build:
    strategy:
      matrix:
        platform:
          - linux/amd64
          - linux/arm64
    runs-on: ${{ matrix.platform }}
    steps:
      - name: Checkout
        uses: actions/checkout@v4
      - name: Login to Gitea
        uses: docker/login-action@v3
        with:
          registry: gitea.jde.nz
          username: DoesntMatter
          password: ${{ secrets.DOCKER_PUSH_TOKEN }}
      - name: Build
        run: |
          ./build.sh
      - name: Test
        run: |
          ./test.sh
      - name: Publish
        run: |
          SOS_WRITE_TOKEN=${{ secrets.SOS_WRITE_TOKEN }} \
          RELEASE_WRITE_TOKEN=${{ secrets.RELEASE_WRITE_TOKEN }} \
          GITEA_CONTAINER_NAME=${{ env.JOB_CONTAINER_NAME }} \
          ./publish.sh
